package org.expeditee.actions;

import javax.mail.Flags.Flag;

import org.expeditee.agents.mail.MailSession;
import org.expeditee.gui.DisplayIO;
import org.expeditee.gui.FrameMouseActions;

public class MailActions {
	/**
	 * Attempts to connect to mail servers
	 */
	public static void connectMail() {
		MailSession.connect();
	}

	/**
	 * Gets any unread mail and attaches it to the cursor for now
	 */
	public static String getAllMailString() {
		String allMail = MailSession.getInstance().getMailString(null, null);
		if (allMail.length() == 0) {
			return "Mailbox empty";
		}
		return allMail;
	}

	public static String getNewMailString() {
		String mail = MailSession.getInstance().getMailString(Flag.RECENT, true);
		if (mail.length() == 0) {
			return "No new mail";
		}
		return mail;
	}

	public static String getUnreadMailString() {
		String mail = MailSession.getInstance().getMailString(Flag.SEEN, false);
		if (mail.length() == 0) {
			return "No unread mail";
		}
		return mail;
	}
	
	public static void getUnreadMail() {
		MailSession.getInstance().getMail(Flag.SEEN, false, DisplayIO.getCurrentFrame(), FrameMouseActions.getPosition());
	}
	
	public static void getAllMail() {
		MailSession.getInstance().getMail(null, null, DisplayIO.getCurrentFrame(), FrameMouseActions.getPosition());
	}
	
	public static void getNewMail() {
		MailSession.getInstance().getMail(Flag.RECENT, true, DisplayIO.getCurrentFrame(), FrameMouseActions.getPosition());
	}

	public static String getUnreadMailCount() {
		try {
			int count = MailSession.getInstance().getFolder()
					.getUnreadMessageCount();
			return count + " unread message" + (count == 1 ? "" : "s");
		} catch (Exception e) {
			return "Mail Error";
		}
	}

	public static String getAllMailCount() {
		try {
			int count = MailSession.getInstance().getFolder().getMessageCount();
			return count + " message" + (count == 1 ? "" : "s");
		} catch (Exception e) {
			return "Mail Error";
		}
	}

	public static String getNewMailCount() {
		try {
			int count = MailSession.getInstance().getFolder()
					.getNewMessageCount();
			return count + " new messages" + (count == 1 ? "" : "s");
		} catch (Exception e) {
			return "Mail Error";
		}
	}

}
