package org.expeditee.io;

import java.io.IOException;

import org.expeditee.gui.Frame;
import org.expeditee.gui.FrameIO;
import org.expeditee.gui.MessageBay;

public class DefaultFramesetWriter extends DefaultFrameWriter {
	private int  _firstFrame = 1;
	private int _maxFrame = Integer.MAX_VALUE;
	
	
	@Override
	protected void outputFrame(Frame toWrite) throws IOException {
		String framesetName = toWrite.getFramesetName();
		int count = FrameIO.getLastNumber(framesetName);

		for (long i = _firstFrame; i <= _maxFrame && i <= count; i++) {
			if (_stop) {
				break;
			}
			String frameName = framesetName + i;
			Frame nextFrame = FrameIO.LoadFrame(frameName);
			if (nextFrame != null) {
				MessageBay.overwriteMessage("Processing " + frameName);
				super.outputFrame(nextFrame);
			}
		}
	}
}
